import { trpc } from "../../trpc";
import {
  calendarExitPriceChartData,
  span,
  openDTE,
  exitDTE,
  lookbackPeriodEnd,
  lookbackPeriodStart,
  similarCalendarPriceChartData,
  stockPriceChartData,
  moniness,
  moninessRadius,
  underlying,
} from "./state";

export const refreshStockPriceChartData = () => {
  stockPriceChartData.value = [];
  trpc.StockPriceChart.getChartData
    .query({
      underlying: underlying.value,
      lookbackPeriodStart: lookbackPeriodStart.value,
      lookbackPeriodEnd: lookbackPeriodEnd.value,
    })
    .then((getChartDataResponse) => {
      stockPriceChartData.value = getChartDataResponse;
    });
};
export const refreshSimilarCalendarPriceChartData = () => {
  similarCalendarPriceChartData.value = [];
  trpc.SimilarCalendarPriceChart.getChartData
    .query({
      underlying: underlying.value,
      daysToFrontExpiration: openDTE.value,
      daysBetweenFrontAndBackExpiration: span.value,
      strikePercentageFromUnderlyingPriceRangeMin:
        (moniness.value - moninessRadius.value) / 100,
      strikePercentageFromUnderlyingPriceRangeMax:
        (moniness.value + moninessRadius.value) / 100,
      lookbackPeriodStart: lookbackPeriodStart.value,
      lookbackPeriodEnd: lookbackPeriodEnd.value,
    })
    .then((getChartDataResponse) => {
      similarCalendarPriceChartData.value = getChartDataResponse;
    });
};
export const refreshcalendarExitPriceChartData = () => {
  calendarExitPriceChartData.value = [];
  trpc.CalendarExitPriceChart.getChartData
    .query({
      underlying: underlying.value,
      daysToFrontExpiration: exitDTE.value,
      daysBetweenFrontAndBackExpiration: span.value,
      lookbackPeriodStart: lookbackPeriodStart.value,
      lookbackPeriodEnd: lookbackPeriodEnd.value,
    })
    .then((getChartDataResponse) => {
      calendarExitPriceChartData.value = getChartDataResponse;
    });
};
